"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.eth8ToEth = exports.ethToEth8 = exports.eth8ToWei = exports.eth8Token = exports.getEthToken = exports.sleep = exports.formatError = exports.payloadId = void 0;
var units_1 = require("@ethersproject/units");
var imx_link_types_1 = require("@imtbl/imx-link-types");
var E = __importStar(require("fp-ts/Either"));
var function_1 = require("fp-ts/function");
var fp_1 = require("./fp");
function payloadId() {
    var datePart = new Date().getTime() * Math.pow(10, 3);
    var extraPart = Math.floor(Math.random() * Math.pow(10, 3));
    var id = datePart + extraPart;
    return id;
}
exports.payloadId = payloadId;
function formatError(err) {
    if (err.response) {
        return new Error(JSON.stringify(err.response.data));
    }
    else if (err.request) {
        return new Error("Errno: " + err.errno + " Errcode: " + err.code);
    }
    else {
        return new Error(err.message);
    }
}
exports.formatError = formatError;
function sleep(time) {
    return new Promise(function (resolve) {
        setTimeout(resolve, time);
    });
}
exports.sleep = sleep;
var getEthToken = function (quantum) {
    return function_1.pipe(Math.pow(10, quantum), String, imx_link_types_1.PositiveIntegerString.decode, E.chain(function (quantum) {
        return E.right({
            type: imx_link_types_1.ETHTokenType.ETH,
            data: {
                quantum: quantum,
            },
        });
    }));
};
exports.getEthToken = getEthToken;
exports.eth8Token = function_1.pipe(exports.getEthToken(8), fp_1.valueOrThrow);
var eth8ToWei = function (amount) {
    return function_1.pipe(amount.mul(Math.pow(10, 8)), imx_link_types_1.PositiveBigNumber.decode, fp_1.valueOrThrow);
};
exports.eth8ToWei = eth8ToWei;
var ethToEth8 = function (amount) {
    return function_1.pipe(units_1.parseEther(amount), function (eth) { return eth.div(Math.pow(10, 8)); }, imx_link_types_1.PositiveBigNumber.decode, fp_1.valueOrThrow);
};
exports.ethToEth8 = ethToEth8;
var eth8ToEth = function (amount) {
    return function_1.pipe(amount.mul(Math.pow(10, 8)), String, units_1.formatEther, imx_link_types_1.PositiveNumberString.decode, fp_1.valueOrThrow);
};
exports.eth8ToEth = eth8ToEth;
//# sourceMappingURL=utils.js.map